#Dans Terminal:
#jupyter lab
#python tp1.py


import matplotlib.pyplot as plt
import numpy as np

def lap(N):
    return 2*np.diag(np.ones(N))-np.diag(np.ones(N-1),-1)-np.diag(np.ones(N-1),1)

def ex1(x):
    return np.pi*np.pi*np.sin(np.pi*x)

def ex2(x):
    return 2*ex1(x)

def ex3(x):
    return np.pi*np.pi*np.sin(np.pi*x/2)/4

def ex4(x):
    return np.pi*np.pi*np.sin(np.pi*x/2)/2


def diff1(n,exf,c):
    h=1/(n+1)
    u=np.zeros(n+2)
    x=np.linspace(0,1,n+2)
    f=exf(x[1:-1])
    #f=np.pi*np.pi*ex1(x[1:-1])
    a=lap(n)+h*h*np.diag(c)
    u[1:-1]=h*h*np.linalg.solve(a,f)
    return x,u


def diff1_mixt(n,exf,c):
    h=1/(n+1)
    u=np.zeros(n+2)
    x=np.linspace(0,1,n+2)
    f=exf(x[1:])
    f[-1]=0
    #f=np.pi*np.pi*ex1(x[1:-1])
    a=lap(n+1)+h*h*np.diag(c)
    a[-1,-1]=1
    u[1:]=h*h*np.linalg.solve(a,f)
    return x,u

    

n=100
h=1/(n+1)
u=np.zeros(n+2)

xx=np.linspace(0,1,1000)
yy=ex1(xx)/np.pi/np.pi

plt.plot(xx,yy)
#plt.show()

    
    
n=100
x,u=diff1(n,ex1,np.zeros(n))

plt.plot(x,u)
plt.plot(xx,yy)
plt.show()


taberr=np.zeros(len(np.arange(50,1000,50)))
i=0
for n in range(50,1000,50):
    x,u=diff1(n,ex1,np.zeros(n))
    plt.plot(x,u-ex1(x)/np.pi/np.pi)
    taberr[i]=np.linalg.norm(u-ex1(x)/np.pi/np.pi)
    i=i+1
plt.show()
    
plt.plot(np.log(np.arange(50,1000,50)),np.log(taberr))
plt.plot(np.log(np.arange(50,1000,50)),-2*np.log(np.arange(50,1000,50)))
plt.plot(np.log(np.arange(50,1000,50)),-np.log(np.arange(50,1000,50)))
plt.show()

n=100
x,u=diff1(n,ex2,np.pi*np.pi*np.ones(n))

plt.plot(x,u)
plt.plot(xx,yy)
plt.show()


taberr=np.zeros(len(np.arange(50,1000,50)))
i=0
for n in range(50,1000,50):
    x,u=diff1(n,ex2,np.pi*np.pi*np.ones(n))
    plt.plot(x,u-ex1(x)/np.pi/np.pi)
    taberr[i]=np.linalg.norm(u-ex1(x)/np.pi/np.pi)
    i=i+1
plt.show()
    
plt.plot(np.log(np.arange(50,1000,50)),np.log(taberr))
plt.plot(np.log(np.arange(50,1000,50)),-2*np.log(np.arange(50,1000,50)))
plt.plot(np.log(np.arange(50,1000,50)),-np.log(np.arange(50,1000,50)))
plt.show()


n=100
x,u=diff1_mixt(n,ex3,np.zeros(n+1))
yy=4*ex3(xx)/np.pi/np.pi

plt.plot(x,u)
plt.plot(xx,yy)
plt.show()

n=100
x,u=diff1_mixt(n,ex4,np.pi*np.pi*np.ones(n+1)/4)
yy=4*ex3(xx)/np.pi/np.pi

plt.plot(x,u)
plt.plot(xx,yy)
plt.show()

taberr=np.zeros(len(np.arange(50,1000,50)))
i=0
for n in range(50,1000,50):
    x,u=diff1_mixt(n,ex4,np.pi*np.pi*np.ones(n+1)/4)
    plt.plot(x,u-4*ex3(x)/np.pi/np.pi)
    taberr[i]=np.linalg.norm(u-4*ex3(x)/np.pi/np.pi)
    i=i+1
plt.show()
    
plt.plot(np.log(np.arange(50,1000,50)),np.log(taberr))
plt.plot(np.log(np.arange(50,1000,50)),-2*np.log(np.arange(50,1000,50)))
plt.plot(np.log(np.arange(50,1000,50)),-np.log(np.arange(50,1000,50)))
plt.show()
