#Dans Terminal:
#jupyter lab
#python tp1.py


import matplotlib.pyplot as plt
import numpy as np

def lap(N):
    return 2*np.diag(np.ones(N))-np.diag(np.ones(N-1),+1)-np.diag(np.ones(N-1),-1)

def dirich(N,f):
    h=1/(N+1)
    a=lap(N)#+h**2*np.diag(c)
    f.shape=(N,1)
    u=np.zeros((N+2,1))
    u[1:-1]=h**2*np.linalg.solve(a,f)
    return u #h**2*np.linalg.solve(a,f)


def dirich1(N,f,c):
    h=1/(N+1)
    a=lap(N)+h**2*np.diag(c)
    f.shape=(N,1)
    u=np.zeros((N+2,1))
    u[1:-1]=h**2*np.linalg.solve(a,f)
    return u #h**2*np.linalg.solve(a,f)

def dirich2(N,f,a,b):
    h=(b-a)/(N+1)
    An=lap(N)#+h**2*np.diag(c)
    f.shape=(N,1)
    u=np.zeros((N+2,1))
    u[1:-1]=h**2*np.linalg.solve(An,f)
    return u #h**2*np.linalg.solve(a,f)




def dirich3(N,f):
    h=1/(N+1)
    a=lap(N)
    f.shape=(N,1)
    u=np.zeros((N+2,1))
    u[1:-1]=h*h*np.linalg.solve(a,f)
    return u 

def dirich4(N,f,c,a,b):
    h=(b-a)/(N+1)
    An=lap(N)+h**2*np.diag(c)
    f.shape=(N,1)
    u=np.zeros((N+2,1))
    u[1:-1]=h**2*np.linalg.solve(An,f)
    return u #h**2*np.linalg.solve(a,f)

def dirich5(N,f):
    h=1/(N+1)
    a=lap(N+1)
    a[-1,-1]=1
    f.shape=(N+1,1)
    u=np.zeros((N+2,1))
    u[1:]=h*h*np.linalg.solve(a,f)
    return u 

def dirich6(N,f,c,a,b):
    h=(b-a)/(N+1)
    An=lap(N+1)+h**2*np.diag(c)
    An[-1,-1]=1
    f.shape=(N+1,1)
    u=np.zeros((N+2,1))
    u[1:]=h**2*np.linalg.solve(An,f)
    return u #h**2*np.linalg.solve(a,f)

def dirich7(N,f,alpha,beta):
    h=1/(N+1)
    a=lap(N)
    b=0.5*np.diag(np.ones(N-1),+1)-0.5*np.diag(np.ones(N-1),-1)
    f.shape=(N,1)
    g=np.zeros(N)
    g[0]=alpha*(1+0.5*h)
    g[-1]=-beta*(0.5*h-1)
    g.shape=(N,1)
    u=np.zeros((N+2,1))
    u[0]=alpha
    u[-1]=beta
    u[1:-1]=np.linalg.solve(a+h*b,h*h*f+g)
    return u 

def dirich8(N,f,alpha,beta):
    h=1/(N+1)
    a=lap(N)
    b=0.5*np.diag(np.ones(N-1),+1)-0.5*np.diag(np.ones(N-1),-1)
    f.shape=(N,1)
    g=np.zeros(N)
    g[0]=-alpha*(0.5*h-1)
    g[-1]=beta*(0.5*h+1)
    g.shape=(N,1)
    u=np.zeros((N+2,1))
    u[0]=alpha
    u[-1]=beta
    u[1:-1]=np.linalg.solve(a-h*b,h*h*f+g)
    return u 


def u1(x):
    return x*(1-x)

def u2(x):
    return x*(2-x)


####### Exemple 1: 

taberr=np.zeros(50)
tabN=np.zeros(50)

aux=np.linspace(0,1,100)
yaux=np.exp(-aux)
plt.plot(aux,yaux)


for i in range(50):
    N=10*(i+1)
    h=1/(N+1)    
    x=np.linspace(0,1,N+2)
    x.shape=(N+2,1)
    f=-2*np.exp(-x)
    u=dirich7(N,f[1:-1],1,1/np.e)    
    y=np.exp(-x)
    a=lap(N+2)
    b=np.diag(np.ones(N+1),+1)-np.diag(np.ones(N+1),-1)
    taberr[i]=np.linalg.norm(np.dot(a+0.5*h*b,u)-h*h*y)
    tabN[i]=N+1
    plt.plot(x,u)


plt.title('Solution exponentielle stable: ')
plt.show()



    
plt.plot(taberr)
plt.title('Evolution de l erreur en fonction du pas')
plt.show()

plt.plot(np.log(tabN),np.log(taberr))
plt.plot(np.log(tabN),-0.5*np.log(tabN)) # orange
plt.plot(np.log(tabN),-np.log(tabN)) # vert
plt.title('Evolution loglog de l erreur en fonction du pas')
plt.show()

######## Exemple 2:

taberr=np.zeros(50)
tabN=np.zeros(50)

aux=np.linspace(0,1,100)
yaux=np.exp(-aux)
plt.plot(aux,yaux)


for i in range(50):
    N=10*(i+1)
    h=1/(N+1)    
    x=np.linspace(0,1,N+2)
    x.shape=(N+2,1)
    f=np.zeros(N+2)
    u=dirich8(N,f[1:-1],1,1/np.e)
    y=np.exp(-x)
    a=lap(N+2)
    b=np.diag(np.ones(N+1),+1)-np.diag(np.ones(N+1),-1)
    taberr[i]=np.linalg.norm(np.dot(a-0.5*h*b,u)-h*h*y)
    tabN[i]=N+1
    plt.plot(x,u)


plt.title('Solution exponentielle stable: ')
plt.show()



    
plt.plot(taberr)
plt.title('Evolution de l erreur en fonction du pas')
plt.show()

plt.plot(np.log(tabN),np.log(taberr))
plt.plot(np.log(tabN),-0.5*np.log(tabN)) # orange
plt.plot(np.log(tabN),-np.log(tabN)) # vert
plt.title('Evolution loglog de l erreur en fonction du pas')
plt.show()



####### Exemple 3: 

taberr=np.zeros(50)
tabN=np.zeros(50)

aux=np.linspace(0,1,100)
yaux=np.exp(aux)
plt.plot(aux,yaux)


for i in range(50):
    N=10*(i+1)
    h=1/(N+1)    
    f=np.zeros(N+2)
    u=dirich7(N,f[1:-1],1,np.e)
    x=np.linspace(0,1,N+2)
    x.shape=(N+2,1)
    y=np.exp(x)
    a=lap(N+2)
    b=np.diag(np.ones(N+1),+1)-np.diag(np.ones(N+1),-1)
    taberr[i]=np.linalg.norm(np.dot(a+0.5*h*b,u)-h*h*y)
    tabN[i]=N+1
    plt.plot(x,u)


plt.title('Solution exponentielle instable: ')
plt.show()



    
plt.plot(taberr)
plt.title('Evolution de l erreur en fonction du pas')
plt.show()

plt.plot(np.log(tabN),np.log(taberr))
plt.plot(np.log(tabN),-0.5*np.log(tabN)) # orange
plt.plot(np.log(tabN),-np.log(tabN)) # vert
plt.title('Evolution loglog de l erreur en fonction du pas')
plt.show()


######## Exemple 4:

taberr=np.zeros(50)
tabN=np.zeros(50)

aux=np.linspace(0,1,100)
yaux=np.exp(aux)
plt.plot(aux,yaux)


for i in range(50):
    N=10*(i+1)
    h=1/(N+1)    
    x=np.linspace(0,1,N+2)
    x.shape=(N+2,1)
    f=-2*np.exp(x)
    u=dirich8(N,f[1:-1],1,np.e)
    y=np.exp(x)
    a=lap(N+2)
    b=np.diag(np.ones(N+1),+1)-np.diag(np.ones(N+1),-1)
    taberr[i]=np.linalg.norm(np.dot(a-0.5*h*b,u)-h*h*y)
    tabN[i]=N+1
    plt.plot(x,u)


plt.title('Solution exponentielle stable: ')
plt.show()



    
plt.plot(taberr)
plt.title('Evolution de l erreur en fonction du pas')
plt.show()

plt.plot(np.log(tabN),np.log(taberr))
plt.plot(np.log(tabN),-0.5*np.log(tabN)) # orange
plt.plot(np.log(tabN),-np.log(tabN)) # vert
plt.title('Evolution loglog de l erreur en fonction du pas')
plt.show()



