#Dans Terminal:
#jupyter lab
#python tp1.py

from mpl_toolkits.mplot3d import Axes3D
import matplotlib.pyplot as plt
import numpy as np


def diffini(n):
    h=1/(n+1)
    h2=h*h
    pi2=np.pi**2
    x,y=np.mgrid[0:(n+2)*h:h,0:(n+2)*h:h]
    ue=np.cos(np.pi*(x+y))
    d=4+2*h2*pi2*np.ones((n+2,n+2)) #((len(x),len(y)))
    fh=h2*2*pi2*np.cos(np.pi*(x+y))
    uh=np.zeros((n+2,n+2))
    aux=h*np.arange(0,n+2)
    uh[:,0]=np.cos(np.pi*aux)
    uh[:,-1]=np.cos(np.pi*(aux+1))
    uh[0,:]=np.cos(np.pi*aux)
    uh[-1,:]=np.cos(np.pi*(aux+1))
    er=np.zeros((n+2,n+2))
    v=uh.copy()
    nt=100
    for n in range(nt):
    #for n in np.arange(0,nt):
        v[1:-1,1:-1]=(fh[1:-1,1:-1]+uh[:-2,1:-1]\
                      +uh[2:,1:-1]+uh[1:-1,:-2]\
                      +uh[1:-1,2:])/d[1:-1,1:-1]
        er=np.abs(uh-v)
        uh=v.copy()
    err=np.max(er)
    return x,y,uh,ue,err


    
n=10
x,y,uh,ue,err=diffini(n)
print('Precision: ',err)
ax=plt.axes(projection='3d')
ax.plot_surface(x,y,uh,color='whitesmoke')
plt.show()


ax=plt.axes(projection='3d')
ax.plot_surface(x,y,ue,color='whitesmoke')
plt.show()

ax=plt.axes(projection='3d')
ax.plot_surface(x,y,uh-ue,color='whitesmoke')
plt.show()


tabn=np.array([2,5,7,10,15,20,38,75])
taberr=np.zeros(len(tabn))
taberrn=np.zeros(len(tabn))
i=0
for n in tabn: # np.arange(0,len(tabn)):
    x,y,uh,ue,err=diffini(n)
    errn=np.max(abs(uh-ue))
    taberr[i]=err
    taberrn[i]=errn
    i+=1

print('Precision: ',taberr)
print('Erreur: ',taberrn)    

taberrn=np.log(taberrn)
tabn=np.log(tabn)
plt.plot(tabn,taberrn,'o-')
plt.show()

taberr0=np.log(taberr[1:])
tabn0=tabn[:-1]
plt.plot(tabn0,taberr0,'o-')
plt.show()





